<?php
/**
* @copyright	Copyright (C) 2013 Jsn Project company. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @package		Easy Profile
* website		www.easy-profile.com
* Technical Support : Forum -	http://www.easy-profile.com/support.html
*/

defined('_JEXEC') or die;

class PlgJsnTab_Article extends JPlugin
{
	public function renderTabs($data, $config)
	{
		$lang = JFactory::getLanguage();
		$lang->load('com_content');
		$plugin=array(JText::_($this->params->get('tabtitle','Articles')));
		$content=$this->getTab($data, $config);
		if(empty($content)) return null;
		$content.='
		<style>
			.justLoaded{display:none;}
		</style>
		<script>
			function tabArticleLoadMore(page)
			{
				
				jQuery("#tabArticleLoadMore td").html("<img src=\"'.JURI::root().'media/plg_jsn_article/loading.gif\" style=\"height:50px;\"/>");
				jQuery.get("index.php?option=com_jsn&view=loadmorearticle&format=raw&uid='.$data->id.'&page="+page,function( data ){jQuery("#tabArticleLoadMore").replaceWith(data);jQuery(".justLoaded").fadeIn(500).removeClass("justLoaded")});
				
			}
		</script>
		';
		$plugin[]=$content;
		return $plugin;
		
	}
	
	public function renderPlugin()
	{
		if(JRequest::getVar('view','')=='loadmorearticle')
		{
			$lang = JFactory::getLanguage();
			$lang->load('com_content');
			$page=JRequest::getInt('page',0);
			$start=$page* (int) $this->params->get('articles_page',10);
			$rows=$this->getList(JRequest::getInt('uid'), null,$start);
			
			foreach($rows as $row)
			{
				$output.=$this->getRow($row);
			}
			if(count($rows) == $this->params->get('articles_page',10)) $output.=$this->getPagination();
			
			echo $output;
		}
		
	}
	
	private function getList($uid, $config, $start=0)
	{
		$com_path = JPATH_SITE.'/components/com_content/';
		require_once $com_path.'helpers/route.php';
		$db=JFactory::getDbo();
		$query=$db->getQuery(true);
		$query->select('a.*,c.title as ctitle')->from('#__content as a,#__categories as c')->where('a.catid=c.id')->where('a.state=1')->where('(a.publish_down > "'.date('Y-m-d H:i:s').'" OR a.publish_down = "0000-00-00")')->where('(a.publish_up < "'.date('Y-m-d H:i:s').'" OR a.publish_up = "0000-00-00")')->where('a.created_by=' . (int) $uid )->order($this->params->get('orderby','a.created DESC'))->setLimit( (int) $this->params->get('articles_page',10), $start);
		if(is_array($this->params->get('catid',null)) && count($this->params->get('catid',null))) {
			$query->where('a.catid IN ('.implode(',',$this->params->get('catid',null)).')');
		}
		$db->setQuery($query);
		$rows = $db->loadAssocList('id');
		return $rows;
	}
	
	private function getTab($data, $config)
	{
		$rows=$this->getList($data->id, $config);
		if(count($rows)==0) {
			if($this->params->get('showEmptyTab',1))
				return JText::_('COM_JSN_NORESULT');
			else
				return null;
		}
		$output=$this->getHeader();
		foreach($rows as $row)
		{
			$output.=$this->getRow($row);
		}
		if(count($rows) == $this->params->get('articles_page',10)) $output.=$this->getPagination();
		$output.=$this->getFooter();
		return $output;
	}
	
	private function getHeader()
	{
		$return=array();
		$return[]='<table class="table table-bordered">';
		return implode('',$return);
		
	}
	
	private function getFooter()
	{
		$return=array();
		
		$return[]='</table>';
		return implode('',$return);
	}
	
	private function getPagination()
	{
		$page=JRequest::getInt('page',0)+1;
		$return=array();
		$return[]='<tr id="tabArticleLoadMore" '.(JRequest::getVar('format','')=='raw' ? 'class="justLoaded"' : '').'><td style="text-align:center"><a class="btn btn-default" href="#" onclick="tabArticleLoadMore('.$page.');return false;">'.JText::_('COM_CONTENT_MORE_ARTICLES').'</a></td></tr>';
		return implode('',$return);
	}
	
	private function getRow($row)
	{
		$slug = $row['id'].':'.$row['alias'];
		$link = JRoute::_(ContentHelperRoute::getArticleRoute($slug, $row['catid'], $row['language']));
		
		$return=array();
		$return[]='	<tr '.(JRequest::getVar('format','')=='raw' ? 'class="justLoaded"' : '').'><td><div class="jsnitem">';
		if($this->params->get('showHits',1)) $return[]='<span class="badge badge-default pull-right">'.JText::sprintf('COM_CONTENT_ARTICLE_HITS', $row['hits']).'</span>';
		$return[]='<div class="jsnitem-title">';
		$return[]='<h5 style="display:inline-block;"><a href="'.$link.'">'.$row['title'].'</a></h5>';
		if($this->params->get('showCategory',1)) $return[]=' <span class="label label-success">'.$row['ctitle'].'</span>';
		$return[]='</div>';
		
		if($this->params->get('showImage',1)) $return[]=     self::articleImage($row);
		if($this->params->get('showIntro',1)) $return[]='     <p>'.self::cleanText($row['introtext'],$this->params->get('introtext_limit',300)).'</p>';
		if($this->params->get('showCreatedDate',1)) $return[]='<small class="pull-right text-muted muted" style="clear:both">'.JText::sprintf('COM_CONTENT_CREATED_DATE_ON', JHtml::_('date', $row['created'], JText::_('DATE_FORMAT_LC3'))).'</small>';
		
		
		$return[]='	</div></td></tr>';
		
		return implode('',$return);
	}
	
	
	private static function articleImage($row)
	{
		$params=json_decode($row['images']);
		if(isset($params->image_intro) && !empty($params->image_intro))
			return '<div class="jsnitem-image pull-left" style="margin: 0 10px 10px 0;"><img style="width:100px;" class="img-rounded" src="'.$params->image_intro.'"/></div>';
		else
			return '';
	}
	
	private static function cleanText($introtext,$introtext_limit)
	{
		$introtext = JHtml::_('content.prepare', $introtext, '', 'plg_tab_article.content');
		$introtext = self::_cleanIntrotext($introtext);
		$introtext = self::truncate($introtext, (int) $introtext_limit );
		return $introtext;
	}


	
	private static function _cleanIntrotext($introtext)
	{
		$introtext = str_replace('<p>', ' ', $introtext);
		$introtext = str_replace('</p>', ' ', $introtext);
		$introtext = strip_tags($introtext, '<a><em><strong>');

		$introtext = trim($introtext);

		return $introtext;
	}

	private static function truncate($html, $maxLength = 0)
	{
		$baseLength = strlen($html);

		// First get the plain text string. This is the rendered text we want to end up with.
		$ptString = JHtml::_('string.truncate', $html, $maxLength, $noSplit = true, $allowHtml = false);

		for ($maxLength; $maxLength < $baseLength;)
		{
			// Now get the string if we allow html.
			$htmlString = JHtml::_('string.truncate', $html, $maxLength, $noSplit = true, $allowHtml = true);

			// Now get the plain text from the html string.
			$htmlStringToPtString = JHtml::_('string.truncate', $htmlString, $maxLength, $noSplit = true, $allowHtml = false);

			// If the new plain text string matches the original plain text string we are done.
			if ($ptString == $htmlStringToPtString)
			{
				return $htmlString;
			}

			// Get the number of html tag characters in the first $maxlength characters
			$diffLength = strlen($ptString) - strlen($htmlStringToPtString);

			// Set new $maxlength that adjusts for the html tags
			$maxLength += $diffLength;

			if ($baseLength <= $maxLength || $diffLength <= 0)
			{
				return $htmlString;
			}
		}

		return $html;
	}
}

?>